local helper = wesnoth.require "lua/helper.lua"
local T = helper.set_wml_tag_metatable {}
-- local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"


function wesnoth.update_stats(unit)
	local health_percentage = unit.hitpoints / unit.max_hitpoints
	local init_mana,init_max_mana = wesnoth.get_mana(unit)
	local mana_percentage = init_mana / init_max_mana
	local side_number = wesnoth.get_variable("side_number")
	local melee_damage_bonus = 0
	local ranged_damage_bonus = 0
	local race, intelligence, strength, dexterity, endurance, total_level, melee_damage, melee_damage_plus, ranged_damage, ranged_damage_plus, melee_precision, ranged_precision, melee_attacks, melee_attacks_plus, ranged_attacks, ranged_attacks_plus,  movement, resist_fire, resist_cold, resist_arcane, resist_blade, resist_impact, resist_pierce, skills, specials_melee, specials_ranged, defense, skills_modified, melee_suck, melee_suck_mana, ranged_suck, ranged_suck_mana, penetrate_fire, penetrate_cold, penetrate_arcane, penetrate_blade, penetrate_impact, penetrate_pierce, magic_damage, melee_type, ranged_type, mana_regen, hitpoints, courage, effects, alignment, class_levels, mana, weapon_type = wesnoth.get_unit_properties(unit)
--	wesnoth.dbms(unit)
	raw_unit = wesnoth.create_unit { type="Hero",  gender=unit.gender, x=unit.x, y=unit.y, canrecruit=true, side=unit.side, moves=unit.moves, attacks_left=unit.attacks_left, name=unit.name, experience=unit.experience, { "variables" , properties }, {"modifications" , {{ "advance", id="basic_properties" ,effects}}}, { "abilities", {}}}
	unit = raw_unit.__cfg
	unit.max_hitpoints = unit.max_hitpoints + endurance * total_level * 0.25 + hitpoints
	unit.hitpoints = unit.max_hitpoints * health_percentage
	for i = 1,#unit do
		if unit[i][1] == "variables" then
			unit[i][2].max_mana = intelligence + mana
			unit[i][2].mana = mana_percentage * unit[i][2].max_mana
			unit[i][2].mana_regen = 1 + (intelligence - intelligence % 10) / 8 + mana_regen
		end
	end
	if skills_modified[207] and weapon_type == "sword" then
		melee_damage_bonus = melee_damage_bonus + (1 + skills_modified[207])
	end
	for i=1,#unit do
		if unit[i][1]=="attack" and unit[i][2].name == "default_attack" then
			if skills_modified[404] then	--We have to check if 404 will be found
				unit[i][2].damage = (unit[i][2].damage + (strength/3) + (intelligence * (1 + skills_modified[404]) * 0.07) + melee_damage_bonus) * ( 100 + melee_damage) / 100 + melee_damage_plus
			else
				unit[i][2].damage = (unit[i][2].damage + (strength/3) + melee_damage_bonus) * ( 100 + melee_damage) / 100 + melee_damage_plus
			end
			if skills_modified[709] then
				unit[i][2].damage = unit[i][2].damage + skills_modified[709] * 2
			end
			unit[i][2].number = unit[i][2].number * ( 100 + melee_attacks + dexterity ^ 0.6 * 15) / 100 + melee_attacks_plus
			unit[i][2].type = melee_type
			for j=1,#unit[i][2] do
				if unit[i][2][j][1] == "specials" then
					for k=1,#unit[i][2][j][2] do
						if unit[i][2][j][2][k][1] == "chance_to_hit" then
							if unit[i][2][j][2][k][2].id == "precision" then
								unit[i][2][j][2][k][2].add = melee_precision + dexterity ^ 0.7
							end
						end
					end
				end
			end
			wesnoth.set_variable("melee_attack",unit[i][2])
		end
		if unit[i][1]=="attack" and unit[i][2].name == "default_ranged_attack" then
			unit[i][2].damage = (unit[i][2].damage + (strength/4) + ranged_damage_bonus) * ( 100 + ranged_damage) / 100 + ranged_damage_plus
			unit[i][2].number = unit[i][2].number * ( 100 + ranged_attacks + dexterity ^ 0.7 * 15) / 100 + ranged_attacks_plus
			unit[i][2].type = ranged_type
			for j=1,#unit[i][2] do
				if unit[i][2][j][1] == "specials" then
					for k=1,#unit[i][2][j][2] do
						if unit[i][2][j][2][k][1] == "chance_to_hit" then
							if unit[i][2][j][2][k][2].id == "precision" then
								unit[i][2][j][2][k][2].add = ranged_precision + dexterity ^ 0.8
							end
						end
					end
				end
			end
			wesnoth.set_variable("ranged_attack",unit[i][2])
		end
	end
	unit.max_experience = wesnoth.calculate_max_experience(total_level)
	unit.alignment = alignment
	unit.race = race
	local cth_modifier = 0
	for i=1,#unit do
		if unit[i][1] == "variables" then
			for j,k in pairs(skills_modified) do
				unit[i][2]["skill_" .. tostring(j)] = k
			end
			if unit[i][2].skill_602 then
				if not unit[i][2].skill_208 then
					unit[i][2].skill_208 = 0
				end
				unit[i][2].skill_208 = unit[i][2].skill_602 + unit[i][2].skill_208
			end
			unit[i][2].magic_damage = magic_damage
		end
	end
	if skills_modified[101] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (1.2 + 0.2 * skills_modified[101])
		current_attack.defense_weight = 0
		current_attack.description = "thrash"
		local percentage = 30 + 2 * skills_modified[101]
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "damage", { id="thrash" , name="thrash", description="Thrash: The attacker using this attack takes " .. tostring(percentage) .. "% more damage." , multiply = 1 + percentage/100, apply_to="opponent"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[102] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.9 + 0.1 * skills_modified[102])
		current_attack.defense_weight = 0
		current_attack.description = "bash"
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "dummy", { id="knockback" , name="knockback", description="Knockback: This attack knocks enemies back." } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[103] then
		resist_blade = resist_blade + 4 + 2 * skills_modified[103]
		resist_impact = resist_impact + 4 + 3 * skills_modified[103]
		resist_pierce = resist_pierce + 4 + 2 * skills_modified[103]
	end
	if skills_modified[104] then
		local damage = (7 + 2 * (skills_modified[104] + skills_modified[104] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="spiritual strike", description="spiritual strike", range="spell", icon="attacks/magic-missile.png", damage=damage, number=1, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=4, description="Spell: This attack is a spell, so it costs 4 mana and has a 100% chance to hit.", value=100, cumulative="no"  } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[105] then
		resist_fire = resist_fire + (skills_modified[105] + 1) * (endurance / 8)
		resist_cold = resist_cold + (skills_modified[105] + 1) * (endurance / 8)
		resist_arcane = resist_arcane + (skills_modified[105] + 1) * (endurance / 8)
	end
	if skills_modified[106] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.85 + 0.15 * skills_modified[106])
		current_attack.defense_weight = 0
		current_attack.description = "fury"
		local percentage = 8 + 2 * skills_modified[106]
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "chance_to_hit", { id="fury" , name="fury", description="Fury: Whenever this attack hits, it has a 50% chance to hit again, but the attacker's chance to get hit is increased by " .. tostring(percentage) .. "%." , add=percentage, apply_to="opponent", cumulative="yes"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[108] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * current_attack.number * (0.85 + 0.15 * skills_modified[108])
		current_attack.number = 1
		current_attack.defense_weight = 0
		current_attack.description = "concentrate"
		local percentage = 78 + 2 * skills_modified[108]
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "chance_to_hit", { id="concentrate" , name="concentrate", description="Concentrate: All the damage of this attack is done in a single blow, with a " .. tostring(percentage) .. "% chance to hit." , value=percentage, apply_to="self", cumulative="yes"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[201] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.85 + 0.15 * skills_modified[201])
		current_attack.defense_weight = 0
		current_attack.description = "confusing attack"
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "attacks", { id="confusing attack" , name="confusing attack", description="Confusing Attack: The target will retaliate one attack less." , sub=1, apply_to="opponent", cumulative="yes"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[202] then
		resist_fire = resist_fire + (skills_modified[202] + 1) * (dexterity / 7)
		resist_cold = resist_cold + (skills_modified[202] + 1) * (dexterity / 7)
		resist_arcane = resist_arcane + (skills_modified[202] + 1) * (dexterity / 7)
	end
	if skills_modified[204] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.9 + 0.1 * skills_modified[204])
		current_attack.defense_weight = 0
		current_attack.description = "bleeding strike"
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "dummy", { id="bleeding" , name="bleeding", description="Bleeding: The target will start taking pierce damage of" .. 8 + skills_modified[204] * 4 .. "points per turn. Lasts for 6 turns in average."  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[205] then
		cth_modifier = cth_modifier + (1 + skills_modified[205]) * strength / 10
	end
	if skills_modified[206] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.8 + 0.2 * skills_modified[206])
		current_attack.defense_weight = 0
		current_attack.description = "desintegration"
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "dummy", { id="desintegration" , name="desintegration", description="Desintegration: The target's physical resistances will be decreased by " .. 5 + skills_modified[206] .. "%. Stacks with itself. Lasts for 6 turns in average."  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[602] then
		if skills_modified[208] then
			skills_modified[208] = skills_modified[208] + skills_modified[602]
		else
			skills_modified[208] = skills_modified[602]
		end
	end
	if skills_modified[208] then
		local damage = (7 + 2 * (2 * skills_modified[208] + skills_modified[208] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="fireball", description="fireball", range="spell", icon="attacks/fireball.png", damage=damage, number=1, type="fire", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=5, description="Spell: This attack is a spell, so it costs 5 mana and has a 100% chance to hit.", value=100, cumulative="no"  } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[209] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.9 + 0.1 * skills_modified[209])
		current_attack.description = "fence"
		local percentage = 34 - skills_modified[209] * 4
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "chance_to_hit", { id="fence" , name="fence", description="Fence: This attack's chance to hit is decreased by " .. tostring(percentage) .. "%, but the opponent's counterattack's chance to hit is divided by three." , sub=percentage, apply_to="self", cumulative="yes"  } } )
				table.insert(current_attack[i][2], { "chance_to_hit", { id="fence-second" , divide=3 , apply_to="opponent", cumulative="yes"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[301] then
		local current_attack = wesnoth.get_variable("ranged_attack")
		current_attack.damage = current_attack.damage * current_attack.number * (0.45 + 0.15 * skills_modified[301])
		current_attack.name = "long_range_ranged_attack"
		current_attack.number = 1
		current_attack.defense_weight = 0
		current_attack.description = "long range shot"
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "attacks", { id="long_range_shot" , name="long range shot", description="Long range shot: This attack cannot be countered", value=0, apply_to="opponent"} } )
				table.insert(current_attack[i][2], { "chance_to_hit", { id="magical" , name="magical", description="Magical: This attacks has always a 70% chance to hit, regardless of the target unit's defensive ability." , value=70, apply_to="self", cumulative="no"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[302] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (1.2 + 0.2 * skills_modified[302])
		current_attack.description = "struggle"
		local percentage = 1.2 + 0.2 * skills_modified[302]
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "chance_to_hit", { id="struggle" , name="struggle", description="Struggle: This attack's chance to hit is decreased by 10%, but its damage is increased by " .. tostring(percentage*100) .. "%." , sub=10, apply_to="self", cumulative="yes"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[304] then
		unit.max_moves = unit.max_moves + 1
		if skills_modified[304] >= 2 then
			for i=1,#unit do
				if unit[i][1] == "movement_costs" then
					local function decrease_cost(terrain_name)
						if unit[i][2][terrain_name] then
							if unit[i][2][terrain_name] > 1 then
								unit[i][2][terrain_name] = unit[i][2][terrain_name] - 1
							end
						end
					end
					decrease_cost("forest")
					decrease_cost("hills")
					decrease_cost("mountains")
					decrease_cost("fungus")
					decrease_cost("frozen")
					if skills_modified[304] >= 3 then
						unit.max_moves = unit.max_moves + 1
					end
					if skills_modified[304] >= 4 then
						decrease_cost("forest")
						decrease_cost("hills")
						decrease_cost("mountains")
						decrease_cost("fungus")
						decrease_cost("frozen")
						decrease_cost("shallow_water")
						decrease_cost("deep_water")
						decrease_cost("coastal_reef")
						decrease_cost("swamp")
					end
					if skills_modified[304] >= 5 then
						unit.max_moves = unit.max_moves + skills_modified[304] - 4
					end
				end
			end
		end
	end
	if skills_modified[306] then
		local current_attack = wesnoth.get_variable("ranged_attack")
		current_attack.defense_weight = 0
		current_attack.description = "penetrating shot"
		local percentage = 0.4 + 0.1 * skills_modified[306]
		if percentage > 1 then
			percentage = 1
			current_attack.damage = current_attack.damage * ((skills_modified[306] - 6) * 0.2 + 1)
		end
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "dummy", { id="penetrating" , name="penetrating", description="Penetrating: This attack will do " .. tostring(percentage*100) .. "% of its damage to the target behind it, and repeat this effect." , value = percentage } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[308] then
		local current_attack = wesnoth.get_variable("ranged_attack")
		current_attack.damage = current_attack.damage * current_attack.number * (0.80 + 0.2 * skills_modified[308])
		current_attack.name = "quick_ranged_attack"
		current_attack.number = 1
		current_attack.defense_weight = 0
		current_attack.description = "rapid shot"
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[309] then
		for i=1,#unit do
			if unit[i][1] == "abilities" then
				local pattern = "*^Fds"
				if skills_modified[309] >= 2 then
					pattern = pattern .. ",*^Fet,*^Fms,*^Fmf,*^Fdf"
				end
				if skills_modified[309] >= 3 then
					pattern = pattern .. ",*^Fetd,*^Ft,*^Fdw,*^Fmv"
				end
				if skills_modified[309] >= 4 then
					pattern = pattern .. ",*^Fda,*^Fma,*^Fpa,*^Uf"
				end
				if skills_modified[309] >= 5 then
					pattern = pattern .. ",*^Ufi,Uh*,Mm*,Ms*,Md*"
				end
				if skills_modified[309] >= 6 then
					pattern = pattern .. ",Hh*,Hhd*,Hd*,Ha*,*^Dr"
				end
				if skills_modified[309] >= 7 then
					pattern = pattern .. "S*,WWr*"
				end
				table.insert(unit[i][2], { "hides", { id="stalk" , name="stalk", name_inactive="stalk", description="Stalk: This unit can hide on a variety of terrains, depending on the skill level, on low levels, it can hide only in deciduous forests, higher skills allow higing also in coniferous forests, autumn and winter forests, on really high levels also in hills and possible even in swamps." , affect_self=true , { "filter_self", {  { "filter_location" , {   terrain=pattern } }  } } } } )

			end
		end
	end
	if skills_modified[401] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.defense_weight = 0
		current_attack.description = "poisonous blow"
		if skills_modified[401] > 5 then
			current_attack.damage = current_attack.damage * (skills_modified[401] * 0.2)
		end
		if skills_modified[401] == 1 then
			for i = 1,#current_attack do
				if current_attack[i][1] == "specials" then
					table.insert(current_attack[i][2], { "dummy", { id="venom" , name="venom", description="Venom: This attack inflicts a status effect that deals 16 damage per turn and lasts for 6 turns in average. Does not stack with itself. Does not affect undead." } } )
				end
			end
		end
		if skills_modified[401] == 2 then
			for i = 1,#current_attack do
				if current_attack[i][1] == "specials" then
					table.insert(current_attack[i][2], { "dummy", { id="toxin" , name="toxin", description="Toxin: This attack inflicts a status effect that deals 24 damage per turn and lasts for 8 turns in average. Does not stack with itself. Does not affect undead."} } )
				end
			end
		end
		if skills_modified[401] == 3 then
			for i = 1,#current_attack do
				if current_attack[i][1] == "specials" then
					table.insert(current_attack[i][2], { "dummy", { id="acid" , name="acid", description="Acid: This attack inflicts a status effect that deals 32 damage per turn and lasts for 6 turns in average. Does not stack with itself. Does affect undead." } } )
				end
			end
		end
		if skills_modified[401] == 4 then
			for i = 1,#current_attack do
				if current_attack[i][1] == "specials" then
					table.insert(current_attack[i][2], { "dummy", { id="miasma" , name="miasma", description="Miasma: This attack inflicts a status effect that deals 40 damage per turn and lasts for 8 turns in average. Does not stack with itself. Does affect undead." } } )
				end
			end
		end
		if skills_modified[401] > 4 then
			for i = 1,#current_attack do
				if current_attack[i][1] == "specials" then
					table.insert(current_attack[i][2], { "dummy", { id="bane" , name="bane", description="Bane: This attack inflicts a status effect that deals 48 damage per turn and lasts for 11 turns in average. Does not stack with itself. Does affect undead." } } )
				end
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[402] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.defense_weight = 0
		current_attack.description = "backstab"
		local percentage = 0.5 + 0.5 * skills_modified[402]
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				local had_backstab = false
				for j = 1,#current_attack[i][2] do
					if current_attack[i][2][j][1] == "damage" then
						if current_attack[i][2][j][2].id == "backstab" then
							current_attack[i][2][j][2].multiply = current_attack[i][2][j][2].multiply + percentage
							current_attack[i][2][j][2].description = "Backstab: When used offensively, this attack deals" .. tostring(current_attack[i][2][j][2].multiply * 100 - 100) .. "% more damage if there is an enemy of the target on the opposite side of the target."
						end
					end
				end
				if backstab == false then
					table.insert(current_attack[i][2], { "damage", { id="backstab" , name="backstab", description="Backstab: When used offensively, this attack deals" .. tostring(current_attack[i][2][j][2].multiply * 100 - 100) .. "% more damage if there is an enemy of the target on the opposite side of the target." , backstab = true, multiply =  current_attack[i][2][j][2].multiply + 1} } )
				end
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[405] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (0.7 + 0.5 * skills_modified[405])
		current_attack.number = 1
		current_attack.defense_weight = 0
		current_attack.description = "crippling strike"
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "dummy", { id="crippling strike" , name="crippling strike", description="Crippling Strike: The target's damage will be decreased by 2. Stacks with itself. Lasts for 6 turns in average."  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[406] then
		local current_attack = { name="toxic cloud", description="toxic cloud", range="spell", icon="attacks/blank-attack.png", damage=1, number=0, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=6, description="Spell: This attack is a spell, so it costs 6 mana and has a 100% chance to hit.", value=100, cumulative="no"  } }, { "dummy", { id="toxin" , name="toxin", description="Toxin: This attack inflicts a status effect that deals 24 damage per turn and lasts for 8 turns in average. Does not stack with itself. Does not affect undead."} } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[407] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.damage = current_attack.damage * (1.2 + 0.3 * skills_modified[407])
		current_attack.description = "targeted thurst"
		local percentage = 1.2 + 0.3 * skills_modified[407]
		for i = 1,#current_attack do
			if current_attack[i][1] == "specials" then
				table.insert(current_attack[i][2], { "chance_to_hit", { id="targeted thurst" , name="targeted thurst", description="Targeted thurst: This attack's chance to hit is decreased by 10%, but its damage is increased by " .. tostring(percentage*100) .. "%." , sub=10, apply_to="self", cumulative="yes"  } } )
			end
		end
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[408] then
		local damage = (7 + 2 * (skills_modified[408] + skills_modified[408] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="shadow blast", description="shadow blast", range="spell", icon="attacks/magic-missile.png", damage=damage, number=1, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=5, description="Spell: This attack is a spell, so it costs 5 mana and has a 100% chance to hit.", value=100, cumulative="no"  } } , { "drain" , { id="drains", name="drains", description="Drain: This unit drains health from living units, healing itself for half the amount of damage it deals." } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[501] then
		local amount = 6 + skills_modified[501] * 6
		for i=1,#unit do
			if unit[i][1] == "abilities" then
				table.insert(unit[i][2], { "heals", { id="healing" , name="heals", description="This unit combines herbal remedies with magic to heal units more quickly than is normally possible on the battlefield.\n\n A unit cared for by this healer may heal up to " .. tostring(amount) .. " HP per turn, or stop poison from taking effect for that turn.\n A poisoned unit cannot be cured of its poison by a healer, and must seek the care of a village or a unit that can cure." , affect_allies=true , affect_self=true, poison="cured", value=amount, { "affect_adjacent", {  adjacent="n,ne,se,s,sw,nw" } } } } )
			end
		end
	end
	if skills_modified[503] then
		local damage = (10 + 3 * (skills_modified[503] + skills_modified[503] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="lightbeam", description="lightbeam", range="spell", icon="attacks/lightbeam.png", damage=damage, number=1, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=6, description="Spell: This attack is a spell, so it costs 6 mana and has a 100% chance to hit.", value=100, cumulative="no"  } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[505] then
		local amount = 2 + skills_modified[505] * 2
		for i=1,#unit do
			if unit[i][1] == "abilities" then
				table.insert(unit[i][2], { "resistance", { id="prayer" , name="prayer", description="This unit's magical abilities will increase the resistances of any adjacent unit by " .. tostring(amount) .. "%." , add=value , max_value=80, cumulative=yes, affect_self=true, affect_allies=true, affect_enemies=false, { "affect_adjacent", {  adjacent="n,ne,se,s,sw,nw" } } } } )
			end
		end
	end
	if skills_modified[506] then
		local current_attack = wesnoth.get_variable("melee_attack")
		current_attack.defense_weight = 0
		current_attack.description = "divine fury"
		current_attack.damage = current_attack.damage * 0.8
		current_attack.number = current_attack.number + 1
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[508] then
		local current_attack = { name="divine blast", description="divine blast", range="spell", icon="attacks/lightbeam.png", damage=24*(1 + magic_damage / 100), number=1, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=11, description="Spell: This attack is a spell, so it costs 11 mana and has a 100% chance to hit.", value=100, cumulative="no"  } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[603] then
		local damage = (7 + 2 * (skills_modified[603] + skills_modified[603] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="freezing bolt", description="freezing bolt", range="spell", icon="attacks/iceball.png", damage=damage, number=1, type="cold", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=5, description="Spell: This attack is a spell, so it costs 5 mana and has a 100% chance to hit.", value=100, cumulative="no" } } , { "slow" , { id="slow", name="slows", description="This attack slows the target until it ends a turn. Slow halves the damage caused by attacks and the movement cost for a slowed unit is doubled. A unit that is slowed will feature a snail icon in its sidebar information when it is selected." } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[604] then
		local damage = (11 + 3 * (skills_modified[604] + skills_modified[604] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="inferno", description="inferno", range="spell", icon="attacks/fire-blast.png", damage=damage, number=1, type="fire", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=6, description="Spell: This attack is a spell, so it costs 6 mana and has a 100% chance to hit.", value=100, cumulative="no" } } , { "dummy", { id="toxin" , name="toxin", description="Toxin: This attack inflicts a status effect that deals 24 damage per turn and lasts for 8 turns in average. Does not stack with itself. Does not affect undead."} } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[605] then
		resist_fire = resist_fire + (skills_modified[605] + 1) * (intelligence / 8)
		resist_cold = resist_cold + (skills_modified[605] + 1) * (intelligence / 8)
		resist_arcane = resist_arcane + (skills_modified[605] + 1) * (intelligence / 8)
	end
	if skills_modified[606] then
		local damage = (7 + 2 * (skills_modified[606] + skills_modified[606] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="ice nova", description="ice nova", range="spell", icon="misc/blank-hex.png", damage=damage, number=1, type="cold", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=9, description="Spell: This attack is a spell, so it costs 9 mana and has a 100% chance to hit.", value=100, cumulative="no" } } , { "slow" , { id="slow", name="slows", description="This attack slows the target until it ends a turn. Slow halves the damage caused by attacks and the movement cost for a slowed unit is doubled. A unit that is slowed will feature a snail icon in its sidebar information when it is selected." } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[608] then
		local damage = (4 + 3 * (skills_modified[608] + skills_modified[608] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="grimcold blast", description="grimcold blast", range="spell", icon="misc/blank-hex.png", damage=damage, number=1, type="cold", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=11, description="Spell: This attack is a spell, so it costs 11 mana and has a 100% chance to hit.", value=100, cumulative="no" } } , { "drain" , { id="drains", name="drains", description="Drain: This unit drains health from living units, healing itself for half the amount of damage it deals." } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[609] then
		local damage = (12 + 4 * (skills_modified[608] + skills_modified[608] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="fire blast", description="fire blast", range="spell", icon="misc/blank-hex.png", damage=damage, number=1, type="fire", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=10, description="Spell: This attack is a spell, so it costs 10 mana and has a 100% chance to hit.", value=100, cumulative="no" } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[703] then
		local current_attack = { name="dark blast", description="dark blast", range="spell", icon="attacks/magic-missile.png", damage=18, number=1, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=6, description="Spell: This attack is a spell, so it costs 6 mana and has a 100% chance to hit.", value=100, cumulative="no"  } } , { "drain" , { id="drains", name="drains", description="Drain: This unit drains health from living units, healing itself for half the amount of damage it deals." } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[705] then
		local damage = (7 + 2 * (skills_modified[705] + skills_modified[705] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="freezing wave", description="freezing wave", range="spell", icon="attacks/iceball.png", damage=damage, number=1, type="cold", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=10, description="Spell: This attack is a spell, so it costs 10 mana and has a 100% chance to hit.", value=100, cumulative="no" } } , { "slow" , { id="slow", name="slows", description="This attack slows the target until it ends a turn. Slow halves the damage caused by attacks and the movement cost for a slowed unit is doubled. A unit that is slowed will feature a snail icon in its sidebar information when it is selected." } } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	if skills_modified[707] then
		local damage = (7 + 2 * (skills_modified[707] + skills_modified[707] ^ 2)) * (1 + magic_damage / 100)
		local current_attack = { name="shades of the fallen", description="shades of the fallen", range="spell", icon="attacks/blank-attack.png", damage=damage, number=1, type="arcane", defense_weight=0, {"specials" , { { "chance_to_hit" , { id="spell", name="spell", mana=6, description="Spell: This attack is a spell, so it costs 6 mana and has a 100% chance to hit.", value=100, cumulative="no"  } },{ "dummy", { id="toxin" , name="toxin", description="Toxin: This attack inflicts a status effect that deals 24 damage per turn and lasts for 8 turns in average. Does not stack with itself. Does not affect undead."} } }} }
		unit[#unit + 1] = { "attack" , current_attack}
	end
	for i=1,#unit do
		if unit[i][1]=="resistance" then
			if skills_modified[701] then
				for j=1,#unit do
					if unit[j][1] == "status" then
						unit[j][2].not_living = true
					end
				end
				unit[i][2].pierce = unit[i][2].pierce - 5 * skills_modified[701]
				unit[i][2].blade = unit[i][2].blade - 3 * skills_modified[701]
				unit[i][2].cold = unit[i][2].cold - 6 * skills_modified[701]
			end
			if defense ~= 0 then
				unit[i][2].pierce = unit[i][2].pierce + 100 * 2 ^ ( -0.02 * defense ^ 0.6) - 100
				unit[i][2].blade = unit[i][2].blade + 100 * 2 ^ ( -0.02 * defense ^ 0.6) - 100
				unit[i][2].impact = unit[i][2].impact + 100 * 2 ^ ( -0.015 * defense ^ 0.5) - 100	--Maces penetrate armors better
			end
			if resist_fire ~= 0 then
				unit[i][2].fire = unit[i][2].fire - resist_fire
				if unit[i][2].fire < 20 then
					unit[i][2].fire = 20
				end
			end
			if resist_cold ~= 0 then
				unit[i][2].cold = unit[i][2].cold - resist_cold
				if unit[i][2].cold < 20 then
					unit[i][2].cold = 20
				end
			end
			if resist_arcane ~= 0 then
				unit[i][2].arcane = unit[i][2].arcane - resist_arcane
				if unit[i][2].arcane < 30 then
					unit[i][2].arcane = 30
				end
			end
			if resist_pierce ~= 0 then
				unit[i][2].pierce = unit[i][2].pierce - resist_pierce
				if unit[i][2].pierce < 20 then
					unit[i][2].pierce = 20
				end
			end
			if resist_blade ~= 0 then
				unit[i][2].blade = unit[i][2].blade - resist_blade
				if unit[i][2].blade < 20 then
					unit[i][2].blade = 20
				end
			end
			if resist_impact ~= 0 then
				unit[i][2].impact = unit[i][2].impact - resist_impact
				if unit[i][2].impact < 20 then
					unit[i][2].impact = 20
				end
			end
		end
	end
	for i=1,#unit do
		if unit[i][1]=="defense" then
			for terrain,value in pairs(unit[i][2]) do
				if value > 70 then
					if dexterity <= 100 then
						unit[i][2][terrain] = 90 - 1.25 * dexterity + 0.01 * dexterity ^ 2 - 0.000025 * dexterity ^ 3 - cth_modifier * 1.5
					else
						unit[i][2][terrain] = 40
					end
				elseif value <= 70 and value >60 then
					if dexterity <= 100 then
						unit[i][2][terrain] = 80 - 1.2 * dexterity + 0.0098 * dexterity ^ 2 - 0.000025 * dexterity ^ 3 - cth_modifier * 1.3
					else
						unit[i][2][terrain] = 33
					end
				elseif value <= 60 and value >50 then
					if dexterity <= 100 then
						unit[i][2][terrain] = 70 - 0.975 * dexterity + 0.0075 * dexterity ^ 2 - 0.00002 * dexterity ^ 3 - cth_modifier
					else
						unit[i][2][terrain] = 27
					end
				elseif value <= 50 and value >40 then
					if dexterity <= 100 then
						unit[i][2][terrain] = 60 - dexterity + 0.0095 * dexterity ^ 2 - 0.00003 * dexterity ^ 3 - cth_modifier * 0.8
					else
						unit[i][2][terrain] = 25
					end
				elseif value <= 40 and value >30 then
					if dexterity <= 100 then
						unit[i][2][terrain] = 50 - 0.85 * dexterity + 0.009 * dexterity ^ 2 - 0.000033 * dexterity ^ 3 - cth_modifier * 0.7
					else
						unit[i][2][terrain] = 23
					end
				elseif value <=30 then
					if dexterity <= 100 then
						unit[i][2][terrain] = 40 - 0.6 * dexterity + 0.007 * dexterity ^ 2 - 0.00003 * dexterity ^ 3 - cth_modifier / 2
					else
						unit[i][2][terrain] = 20
					end
				end
				if skills_modified[409] then
					unit[i][2][terrain] = unit[i][2][terrain] * 0.96 ^ skills_modified[409]
				end
			end
		end
	end
	unit = wesnoth.display_mana(unit)
	return unit
end

function wesnoth.wml_actions.show_unit_properties()
	local side_number = wesnoth.get_variable("side_number")
	local raw_unit = wesnoth.get_units { canrecruit=true , side=side_number }
	local unit = raw_unit[1].__cfg

	local dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
		T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Character Properties"} }} ,
			T.row { T.column { T.grid { T.row { T.column { T.label { id = "gui_experience_display", label="Experience: 0/0"}},
				T.column { T.button { id = "gui_level_up", label = "Level-up" , tooltip="Opens the advancing window." }}
			}}}},
			T.row { T.column { T.grid { T.row { T.column { T.button { id = "gui_export", label = "Export character" , tooltip="Move the character outside the save file to load it later, in another game. It is recommended to do this if you are leaving a game." }},
				T.column { T.button { id = "gui_import", label = "Import character" , tooltip="Imports a previously exported character." }}
			}}}},
			T.row { T.column { T.scroll_label { id = "gui_message", label = " " } }},
			T.row { T.column { T.button { id = "ok", label = "Back" , tooltip="Return to game." } }}

		}}
	local function preshow()
		local function describe(unit)
				local race, intelligence, strength, dexterity, endurance, total_level, melee_damage, melee_damage_plus, ranged_damage, ranged_damage_plus, melee_precision, ranged_precision, melee_attacks, melee_attacks_plus, ranged_attacks, ranged_attacks_plus,  movement, resist_fire, resist_cold, resist_arcane, resist_blade, resist_impact, resist_pierce, skills, specials_melee, specials_ranged, defense, skills_modified, melee_suck, melee_suck_mana, ranged_suck, ranged_suck_mana, penetrate_fire, penetrate_cold, penetrate_arcane, penetrate_blade, penetrate_impact, penetrate_pierce, magic_damage, melee_type, ranged_type, mana_regen, hitpoints, courage, effects, alignment, class_levels, mana, weapon_type = wesnoth.get_unit_properties(unit)
			local resistances
			local function round(number)
				return (number - number % 1)
			end
			local function edit_to_resist(number)
				return (100 - round(number)) .. "%"
			end
			for i=1,#unit do
				if unit[i][1]=="resistance" then
					resistances = unit[i][2]
				end
				if unit[i][1]=="variables" then
					variables = unit[i][2]
				end
			end
			local spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost = wesnoth.setup_skills_descriptions(variables,magic_damage)
			local message = "\nName: " .. unit.name .. "\nRace: " .. race .. "\nAlignment: " .. unit.alignment .. "\nLevel: " ..  total_level .. "\nDefense: " .. defense .. "\n\nAttributes:\nStrength: " .. strength .. "\nDexterity: " .. dexterity .. "\nEndurance: " .. endurance .. "\nIntelligence: " .. intelligence .. "\n\nResistances:\nArcane: " .. edit_to_resist(resistances.arcane) .. "\nFire: " .. edit_to_resist(resistances.fire) .. "\nCold: " .. edit_to_resist(resistances.cold) .. "\nBlade: " .. edit_to_resist(resistances.blade) .. "\nImpact: " .. edit_to_resist(resistances.impact) .. "\nPierce: " .. edit_to_resist(resistances.pierce) .. "\n\nAttacks:" 
			for i=1,#unit do
				if unit[i][1]=="attack" then
					message = message .. "\n" .. unit[i][2].description .. ": " .. round(unit[i][2].damage) .. "-" .. round(unit[i][2].number) .. " " .. unit[i][2].type .. " (" .. unit[i][2].range .. ")"
				end
			end
			message = message .. "\n\nSpells:"
			local found_spells = false
			for i,j in pairs(spells_names_ingame) do
				found_spells = true
				message = message .. "\n" .. j .. ": " .. spells_descriptions[i]
				if spells_costs[i] > 0 then
					message = message .. " (Mana cost: " .. spells_costs[i] .. ")"
				end
				if enchantment_cost[i] > 0 then
					message = message .. " (Mana cost: " .. enchantment_cost[i] .. " per turn)"
				end
			end
			if found_spells == false then
				message = message .. "\nnone"
			end
			return message
		end
		local function export()
			wesnoth.wml_actions.get_global_variable { namespace="various_world_of_wesnoth", from_global="heroes_vault", to_local="heroes_vault" }
			local heroes = wesnoth.get_variable( "heroes_vault" )
			if #heroes == 0 then
				heroes = {}
			end
			local variables = helper.get_child(unit, "variables")
			local list = {}
			for i = 1,#variables do
				if variables[i][1] == "a" then
					table.insert(list , variables[i][2].id)
				end
			end
			local list_finished = table.concat(list, ',')
			list_finished = list_finished .. "," .. tostring(3000000 + unit.experience)
			table.insert(heroes , { "hero" , { name = unit.name , description = list_finished, gender=unit.gender}})
			wesnoth.set_variable("heroes_vault" , heroes)
			wesnoth.wml_actions.set_global_variable { namespace="various_world_of_wesnoth", to_global="heroes_vault", from_local="heroes_vault", immediate=true }
		end
		local function import()
			local creation = wesnoth.import_character({cannot_cancel=false})
			if creation then
				unit=creation
			end
			wesnoth.set_dialog_value(describe(unit), "gui_message" )
			wesnoth.set_dialog_value( "Experience: " .. unit.experience .. "/" .. unit.max_experience .. " " , "gui_experience_display")
			if unit.experience >= unit.max_experience then
				wesnoth.set_dialog_active( true, "gui_level_up")
			else
				wesnoth.set_dialog_active( false, "gui_level_up")
			end	
		end
		local function level_up()
			unit = wesnoth.level_up()
			wesnoth.set_dialog_value(describe(unit), "gui_message" )
			wesnoth.set_dialog_value( "Experience: " .. unit.experience .. "/" .. unit.max_experience .. " " , "gui_experience_display")
			if unit.experience >= unit.max_experience then
				wesnoth.set_dialog_active( true, "gui_level_up")
			else
				wesnoth.set_dialog_active( false, "gui_level_up")
			end
		end
		wesnoth.set_dialog_value( "Experience: " .. unit.experience .. "/" .. unit.max_experience .. " " , "gui_experience_display")
		if unit.experience < unit.max_experience then
			wesnoth.set_dialog_active( false, "gui_level_up")
		end
		if unit.experience >= unit.max_experience then
			wesnoth.set_dialog_active( true, "gui_level_up")
		end
		wesnoth.set_dialog_callback(level_up, "gui_level_up")
		wesnoth.set_dialog_callback(export, "gui_export")
		wesnoth.set_dialog_callback(import, "gui_import")
		wesnoth.set_dialog_value(describe(unit), "gui_message" )
	end

	local function postshow()
	end

	wesnoth.show_dialog(dialog, preshow, postshow)

end

function wesnoth.import_character(cfg)
	wesnoth.wml_actions.get_global_variable { namespace="various_world_of_wesnoth", from_global="heroes_vault", to_local="heroes_vault" }
	local heroes = wesnoth.get_variable( "heroes_vault" )
	local unit_import = nil
	if #heroes == 0 then
		if cfg.cannot_cancel == true then
			wesnoth.message_box("You have no characters exported. Character creation window will be open instead.")
			wesnoth.wml_actions.character_creation()
		else
			wesnoth.message_box("You have no characters exported.")
		end
	else
		local character_chosen
		local import_dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
			T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Import Hero"} }} ,
				T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_character_chosen", 
					T.list_definition { T.row { T.column { horizontal_grow = true,
						T.toggle_panel { tooltip="The list of characters you have exported.", T.grid { T.row {
							T.column { T.image { id = "gui_character_image" } },
		   					T.column { T.grid { 
								T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_character_name" } }},
								T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_character_experience" } }}
							}}
						}}}
					}}}
				}}},
				T.row { T.column { T.grid { T.row {
					T.column { T.button { id = "ok", label = "Import character" , tooltip="Import the selected character replacing your current one. It is advised to export your current character first." } },
					T.column { T.button { id = "cancel", label = "Back", tooltip="Back to game." } }
				}}}}
			}}
		local function import_preshow()
			local function select_character()
				wesnoth.set_dialog_active( true, "ok")
				character_chosen = wesnoth.get_dialog_value "gui_character_chosen"
			end
			for i = 1,#heroes do
				local experience = 0
				for j in string.gmatch( heroes[i][2].description , "[^%s,][^,]*") do
					if tonumber(j) >= 3000000 then
						experience = j - 3000000
					end
				end
				wesnoth.set_dialog_value("misc/blank-hex.png" , "gui_character_chosen", i , "gui_character_image")
				wesnoth.set_dialog_value(heroes[i][2].name , "gui_character_chosen", i , "gui_character_name")
				wesnoth.set_dialog_value("Experience: " .. experience , "gui_character_chosen", i , "gui_character_experience")
			end
			wesnoth.set_dialog_active( false, "ok")
			wesnoth.set_dialog_callback(select_character, "gui_character_chosen")
			if cfg.cannot_cancel == true then
				wesnoth.set_dialog_active( false, "cancel")
			end
		end
		local function import_postshow()
		end
		local did_choose = wesnoth.show_dialog(import_dialog,import_preshow,import_postshow)
		local experience = 0
		if did_choose == -1 then
			local raw_description = heroes[character_chosen][2].description
			local properties = {}
			for j in string.gmatch( heroes[character_chosen][2].description , "[^%s,][^,]*") do
				if tonumber(j) >= 3000000 then
					experience = j - 3000000
				else
					table.insert( properties , { "a" , { id=j }} )
				end
			end
			local side_number = wesnoth.get_variable("side_number")
			local raw_unit_import = wesnoth.get_units { canrecruit=true , side=side_number }
			unit_import = raw_unit_import[1].__cfg
			local health_percentage = unit_import.hitpoints / unit_import.max_hitpoints
			local mana_percentage
			for i = 1,#unit_import do
				if unit_import[i][1] == "variables" then
					if unit_import[i][2].mana and unit_import[i][2].max_mana then
						mana_percentage = tonumber(unit_import[i][2].mana) / tonumber(unit_import[i][2].max_mana)
					else
						mana_percentage = 1
					end
				end
			end
			properties.mana = 10 * mana_percentage
			properties.max_mana = 10
			properties.mana_to_pay = 0
			raw_unit_import = wesnoth.create_unit { type="Hero", experience=experience, gender=heroes[character_chosen][2].gender, x=unit_import.x, y=unit_import.y, canrecruit=true, side=side_number, name=heroes[character_chosen][2].name, moves=0, attacks_left=0, { "variables" , properties }}
			unit_import = raw_unit_import.__cfg
			unit_import.hitpoints = health_percentage * unit_import.max_hitpoints
			unit_import = wesnoth.update_stats(unit_import)
			wesnoth.put_unit(unit_import)
		end		
	end
	return unit_import
end

function wesnoth.wml_actions.import_character(cfg)
	wesnoth.import_character(cfg)
end
