local helper = wesnoth.require "lua/helper.lua"
local T = helper.set_wml_tag_metatable {}
-- local debug_utils = wesnoth.require "~add-ons/World_of_Wesnoth/lua/utils.lua"

function wesnoth.setup_skills_descriptions(skills,magic_damage)
	local spells_names = {}
	local spells_costs = {}
	local spells_descriptions = {}
	local spells_names_ingame = {}
	local enchantment_cost = {}
	local summon = {}
	if skills.skill_104 then
		spells_names[104] = "spiritual_strike"
		spells_costs[104] = 4
		spells_descriptions[104] = "Deals " .. tostring((7 + 2 * (skills.skill_104 + skills.skill_104 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target."
		spells_names_ingame[104] = "Spiritual Strike"
		enchantment_cost[104] = 0	--isn't an enchantment
		summon[104] = 0			--isn't a summon
	end
	if skills.skill_107 then
		spells_names[107] = "spiritual_recovery"
		spells_costs[107] = 8 + skills.skill_107
		spells_descriptions[107] = "Recovers " .. tostring(15 + skills.skill_107 * 10) .. "% hitpoints (self only)."
		spells_names_ingame[107] = "Spiritual Recovery"
		enchantment_cost[107] = 0
		summon[107] = 0
	end
	if skills.skill_203 then
		spells_names[203] = "flaming_weapon"
		spells_costs[203] = 0
		spells_descriptions[203] = "Adds " .. tostring((4 + skills.skill_203 ^2)*(1 + magic_damage/100)) .. " fire damage to each hit with any melee attack."
		spells_names_ingame[203] = "Flaming Weapon"
		enchantment_cost[203] = 1
		summon[203] = 0
	end
	if skills.skill_208 then
		spells_names[208] = "fireball"
		spells_costs[208] = 5
		spells_descriptions[208] = "Deals " .. tostring((7 + 2 * (skills.skill_208 ^ 2 + skills.skill_208 * 2 ))*(1 + magic_damage/100)) .. " fire damage to the target and a half of it to all enemies adjacent to it."
		spells_names_ingame[208] = "Fireball"
		enchantment_cost[208] = 0
		summon[208] = 0
	end
	if skills.skill_301 then
		spells_names[301] = "long_range_shot"
		spells_costs[301] = 1
		spells_descriptions[301] = "Hits with the ranged attack for " .. tostring(100*(0.45 + 0.15 * skills.skill_301)) .. "% of original total damage damage with 70% chance to hit."
		spells_names_ingame[301] = "Long Range Shot"
		enchantment_cost[301] = 0
		summon[301] = 0
	end
	if skills.skill_303 then
		spells_names[303] = "leeches"
		spells_costs[303] = 0
		spells_descriptions[303] = "Drains " .. tostring((4 + 2*skills.skill_303)*(1 + magic_damage/100)) .. " hitpoints from every adjacent unit to the target, healing the target."
		spells_names_ingame[303] = "Leeches"
		enchantment_cost[303] = 1
		summon[303] = 0
	end
	if skills.skill_305 then
		spells_names[305] = "animal_follower"
		spells_costs[305] = 5
		spells_descriptions[305] = "Summons an animal follower to fight on your side."
		spells_names_ingame[305] = "Animal Follower"
		enchantment_cost[305] = 1
		summon[305] = 1
	end
	if skills.skill_403 then
		spells_names[403] = "summon_shadow"
		spells_costs[403] = 5
		spells_descriptions[403] = "Summons a shadow to fight on your side."
		spells_names_ingame[403] = "Summon Shadow"
		enchantment_cost[403] = 1
		summon[403] = 1
	end
	if skills.skill_406 then
		spells_names[406] = "toxic_cloud"
		spells_costs[406] = 6
		spells_descriptions[406] = "Poisons all enemies in range" .. tostring(skills.skill_406) .. "hexes from the main target. Cooldown 2 turns."
		spells_names_ingame[406] = "Toxic Cloud"
		enchantment_cost[406] = 0
		summon[406] = 0
	end
	if skills.skill_408 then
		spells_names[408] = "shadow_blast"
		spells_costs[408] = 5
		spells_descriptions[408] = "Deals " .. tostring((7 + 2 * (skills.skill_408 + skills.skill_408 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target, draining back a half of it."
		spells_names_ingame[408] = "Shadow Blast"
		enchantment_cost[408] = 0
		summon[408] = 0
	end
	if skills.skill_502 then
		spells_names[502] = "divine_might"
		spells_costs[502] = 0
		spells_descriptions[502] = "Adds " .. tostring((10 + skills.skill_502 * 10)*(1 + magic_damage/100)) .. "% of original melee attacks' damage as arcane damage."
		spells_names_ingame[502] = "Divine Might"
		enchantment_cost[502] = 2
		summon[502] = 0
	end
	if skills.skill_503 then
		spells_names[503] = "lightbeam"
		spells_costs[503] = 6
		spells_descriptions[503] = "Deals " .. tostring((10 + 3 * (skills.skill_503 + skills.skill_503 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a single target."
		spells_names_ingame[503] = "Spiritual Strike"
		enchantment_cost[503] = 0
		summon[503] = 0
	end
	if skills.skill_504 then
		spells_names[504] = "heal"
		spells_costs[504] = 9
		spells_descriptions[504] = "Recovers " .. tostring(15 + skills.skill_504 ^ 2 * 10) .. " hitpoints."
		spells_names_ingame[504] = "Heal"
		enchantment_cost[504] = 0
		summon[504] = 0
	end
	if skills.skill_507 then
		spells_names[507] = "holy_armor"
		spells_costs[507] = 0
		spells_descriptions[507] = "Heaks " .. tostring(7 + skills.skill_507 * 3) .. "% of damage taken by normal means."
		spells_names_ingame[507] = "Holy Armor"
		enchantment_cost[507] = 1
		summon[507] = 0
	end
	if skills.skill_508 then
		spells_names[508] = "divine_blast"
		spells_costs[508] = 11
		spells_descriptions[508] = "Deals " .. tostring(24*(1 + magic_damage/100)) .. " arcane damage to enemies in range of " .. tostring(skills.skill_508) .. " hexes."
		spells_names_ingame[508] = "Divine Blast"
		enchantment_cost[508] = 0
		summon[508] = 0
	end
	if skills.skill_509 then
		spells_names[509] = "magical_mirror"
		spells_costs[509] = 0
		spells_descriptions[509] = "Returns " .. tostring(30 + skills.skill_509 * 10) .. "% of fire, cold and arcane damage back to attackers."
		spells_names_ingame[509] = "Magical Mirror"
		enchantment_cost[509] = 1
		summon[509] = 0
	end
	if skills.skill_601 then
		spells_names[509] = "steel_skin"
		spells_costs[509] = 0
		spells_descriptions[509] = "Returns and heals back " .. tostring(7 + skills.skill_601 * 3) .. "% of blade, pierce and impact damage taken."
		spells_names_ingame[509] = "Steel Skin"
		enchantment_cost[509] = 2
		summon[509] = 0
	end
	if skills.skill_603 then
		spells_names[603] = "freezing_bolt"
		spells_costs[603] = 5
		spells_descriptions[603] = "Deals " .. tostring((7 + 2 * (skills.skill_603 + skills.skill_603 ^ 2))*(1 + magic_damage/100)) .. " cold damage to a single target, slowing it."
		spells_names_ingame[603] = "Freezing Bolt"
		enchantment_cost[603] = 0
		summon[603] = 0
	end
	if skills.skill_604 then
		spells_names[604] = "inferno"
		spells_costs[604] = 5
		spells_descriptions[604] = "Deals " .. tostring((11 + 3 * (skills.skill_604 + skills.skill_604 ^ 2))*(1 + magic_damage/100)) .. " fire damage to a single target, poisoning it."
		spells_names_ingame[604] = "Freezing Bolt"
		enchantment_cost[604] = 0
		summon[604] = 0
	end
	if skills.skill_607 then
		spells_names[607] = "create_golem"
		spells_costs[607] = 5
		spells_descriptions[607] = "Creates a golem to fight on your side."
		spells_names_ingame[607] = "Create Golem"
		enchantment_cost[607] = 1
		summon[607] = 1
	end
	if skills.skill_608 then
		spells_names[608] = "grimcold_blast"
		spells_costs[608] = 11
		spells_descriptions[608] = "Deals " .. tostring((4 + 3 * (skills.skill_608 + skills.skill_608 ^ 2))*(1 + magic_damage/100)) .. " cold damage and " .. tostring((8 + (skills.skill_608 + skills.skill_608 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to target in a 1-hex range, healing a half of the damage dealt. Can drain also undead."
		spells_names_ingame[608] = "Grimcold blast"
		enchantment_cost[608] = 0
		summon[608] = 0
	end
	if skills.skill_702 then
		spells_names[702] = "summon_skeleton"
		spells_costs[702] = 7
		spells_descriptions[702] = "Creates a skeleton to fight on your side. Maximum number of skeletons is " .. tostring(skills.skill_702) .. "."
		spells_names_ingame[702] = "Summon Skeleton"
		enchantment_cost[702] = 0
		summon[702] = skills.skill_702
	end
	if skills.skill_703 then
		spells_names[703] = "dark_blast"
		spells_costs[703] = 6
		if skills.skill_703 == 1 then
			spells_descriptions[703] = "Deals 18 arcane damage to a single target, draining back a half of it."
		else
			spells_descriptions[703] = "Deals 18 arcane damage to a group of targets in the range of " .. tostring(skills.skill_703-1) .. " hexes from the main target, draining back a half of it."
		end
		spells_names_ingame[703] = "Dark Blast"
		enchantment_cost[703] = 0
		summon[703] = 0
	end
	if skills.skill_704 then
		spells_names[704] = "foul_cloak"
		spells_costs[704] = 0
		if skills.skill_717 then
			spells_descriptions[704] = "Adds a poison that deals " .. tostring((1 + skills.skill_704 + skills.skill_717)*8) .. " damage per turn (lasts for 8 turns in average) to melee attacks."
		else
			spells_descriptions[704] = "Adds a poison that deals " .. tostring((1 + skills.skill_704) * 8) .. " damage per turn (lasts for 8 turns in average) to melee attacks."
		end
		spells_names_ingame[704] = "Foul Cloak"
		enchantment_cost[704] = 1
		summon[704] = 0
	end
	if skills.skill_705 then
		spells_names[705] = "freezing_wave"
		spells_costs[705] = 10
		spells_descriptions[705] = "Deals " .. tostring((7 + 2 * (skills.skill_705 + skills.skill_705 ^ 2))*(1 + magic_damage/100)) .. " cold damage to a group of targets within the range of 1 hex, slowing them."
		spells_names_ingame[705] = "Freezing Wave"
		enchantment_cost[705] = 0
		summon[705] = 0
	end
	if skills.skill_706 then
		spells_names[706] = "summon_skeletal_archer"
		spells_costs[706] = 8
		spells_descriptions[706] = "Creates a skeletal archer to fight on your side. Maximum number of skeletons is " .. tostring(skills.skill_706) .. "."
		spells_names_ingame[706] = "Summon Skeletal Archer"
		enchantment_cost[706] = 0
		summon[706] = skills.skill_706
	end
	if skills.skill_707 then
		spells_names[707] = "shades_of_the_fallen"
		spells_costs[707] = 6
		spells_descriptions[707] = "Deals " .. tostring((7 + 2 * (skills.skill_707 + skills.skill_707 ^ 2))*(1 + magic_damage/100)) .. " arcane damage to a group of targets within the range of 2 hexes, poisoning them."
		spells_names_ingame[707] = "Shades of the Fallen"
		enchantment_cost[707] = 0
		summon[707] = 0
	end
	return spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost,summon
end

function wesnoth.wml_actions.show_spells(cfg)
	local side_number = wesnoth.get_variable("side_number")
	local raw_unit = wesnoth.get_units { canrecruit=true , side=side_number }
	local unit = raw_unit[1].__cfg
	local target = {}
	local self = cfg.self
	local friendly = cfg.friendly
	local empty = cfg.empty
	local enemy
	local spell_chosen
	if not empty and not friendly then
		enemy = true
	end
	local mana,max_mana = wesnoth.get_mana(unit)
	if empty then
		target.x = cfg.x
		target.y = cfg.y
	else
		local raw_target = wesnoth.get_units { x=cfg.x, y=cfg.y }
		target = raw_target[1].__cfg
	end
	local skills = {}
	for i = 1,#unit do
		if unit[i][1] == "variables" then
			skills = unit[i][2]
		end
	end
	local cooldowns = {}
	for i = 1,#skills do
		if skills[i][1] == "cooldowns" then
			cooldowns = skills[i][2]
		end
	end
	local spells_names,spells_costs,spells_descriptions,spells_names_ingame,enchantment_cost,summon = wesnoth.setup_skills_descriptions(skills,skills.magic_damage)
	local dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
		T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Spells"} }} ,
			T.row { T.column { T.label { id = "gui_mana_display", label="Mana: 0/0"}}},
			T.row { T.column { T.scroll_label { id = "gui_description", label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "gui_enchantments", label = "Enchantments" , tooltip="See a list of enchantments that are draining your mana." } }
			}}}},
			T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_spell_chosen", 
				T.list_definition { T.row { T.column { horizontal_grow = true,
					T.toggle_panel { tooltip="The list of spells that can be cast on the selected location.", T.grid { T.row {
						T.column { T.image { id = "gui_spell_icon" } },
	   					T.column { T.grid { 
							T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_spell_name" } }},
							T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_spell_cost" } }}
						}}
					}}}
				}}}
			}}},
			T.row { T.column { T.grid { T.row {
				T.column { T.button { id = "ok", label = "Cast Spell" , tooltip="Cast the selected spell." } },
				T.column { T.button { id = "cancel", label = "Back", tooltip="Back to game." } }
			}}}}
		}}
	local function preshow()
		local function select()
			spell_chosen = wesnoth.get_dialog_value "gui_spell_chosen"
			wesnoth.set_dialog_active( true , "ok")
			wesnoth.set_dialog_value( spells_descriptions[spell_chosen] , "gui_description")
		end
		local function enchantments()
			local done = false
				while done == false do
				local raw_units = wesnoth.get_units({{ "filter_wml", { { "variables", {  enchanted=true }  } } }})
				local enchantments = {}
				local enchantment_chosen
				if #raw_units > 0 then
					for i=1,#raw_units do
						local unit = raw_units[i].__cfg
						for j=1,#unit do
							if unit[j][1] == "variables" then
								for k=1,#unit[j][2] do
									if unit[j][2][k][1] == "enchantment" then
										if unit[j][2][k][2].caster == side_number then
											table.insert(enchantments, { image="misc/blank-hex.png", name=unit.name, number=unit[j][2][k][2].number, id=unit.id })
										end

									end
								end
							end
						end
					end
					if  #enchantments > 0 then
						local enchantments_dialog = { T.tooltip { id = "tooltip_large" }, T.helptip { id = "tooltip_large" },  maximum_height = 600, maximum_width = 800,
							T.grid { T.row { T.column { T.label { id="title" , definition="title" , label="Enchantments"} }} ,
								T.row { T.column { T.scroll_label { id = "gui_description", label="                                                                                                                                   \n                                                                                                                                   \n                                                                                                                                   \n"}}},
								T.row {	T.column { horizontal_grow = true, T.listbox { id = "gui_enchantment_chosen", 
									T.list_definition { T.row { T.column { horizontal_grow = true,
										T.toggle_panel { tooltip="The list of enchantments that are draining your mana.", T.grid { T.row {
											T.column { T.image { id = "gui_enchantment_icon" } },
											T.column { T.image { id = "gui_enchantment_target" } },
						   					T.column { T.grid { 
												T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_enchantment_name" } }},
												T.row { T.column { horizontal_alignment = "left", T.label { id = "gui_enchantment_cost" } }}
											}}
										}}}
									}}}
								}}},
							T.row { T.column { T.grid { T.row {
								T.column { T.button { id = "ok", label = "Cancel enchantment" , tooltip="Cancels the selected enchantment." } },
								T.column { T.button { id = "cancel", label = "Back", tooltip="Back to spells menu." } }
							}}}}
							}}
						local function enchantments_preshow()
							local function select()
								enchantment_chosen = wesnoth.get_dialog_value "gui_enchantment_chosen"
								wesnoth.set_dialog_active( true , "ok")
								wesnoth.set_dialog_value( spells_descriptions[enchantments[enchantment_chosen].number] , "gui_description")
							end
							wesnoth.set_dialog_callback(select, "gui_enchantment_chosen")
							wesnoth.set_dialog_active( false , "ok")
							for i=1,#enchantments do
								wesnoth.set_dialog_value("misc/blank-hex.png" , "gui_enchantment_chosen", i , "gui_enchantment_icon")
								wesnoth.set_dialog_value(enchantments[i].image , "gui_enchantment_chosen", i , "gui_enchantment_target")
								wesnoth.set_dialog_value(spells_names_ingame[enchantments[i].number] .. " (" .. enchantments[i].name .. ")"  , "gui_enchantment_chosen", i , "gui_enchantment_name")
								wesnoth.set_dialog_value("Mana cost: " .. enchantment_cost[enchantments[i].number]  , "gui_enchantment_chosen", i , "gui_enchantment_cost")
							end

						end
						local function enchantments_postshow()
						end
						local choice = wesnoth.show_dialog(enchantments_dialog, enchantments_preshow, enchantments_postshow)
						if choice == -1 then
							local raw_target = wesnoth.get_units { id=enchantments[enchantment_chosen].id }
							local target = raw_target[1].__cfg
							for i = 1,#target do
								if target[i][1] == "variables" then
									for j=1,#target[i][2] do
										if target[i][2][j][1] == "enchantment" then
											if target[i][2][j][2].number == enchantments[enchantment_chosen].number then
												target[i][2][spells_names[enchantments[enchantment_chosen].number]] = nil
												target[i][2][spells_names[enchantments[enchantment_chosen].number].. "_level"] = nil
												table.remove(target[i][2],j)
												break
											end
										end
									end
									local enchanted = false
									for j=1,#target[i][2] do
										if target[i][2][j][1] == "enchantment" then
											enchanted = true
										end
									end
									if enchanted == false then
										target[i][2].enchanted = nil
									end
								end
							end
							wesnoth.put_unit(target)
							if unit.id == target.id then
								unit = target
							end
						else
							done = true
						end
					else
						done = true
						wesnoth.set_dialog_value( "You are not actively keeping an enchantment on anything." , "gui_description")
					end
				else
					wesnoth.set_dialog_value( "You are not actively keeping an enchantment on anything." , "gui_description")
					done = true
				end
			end
		end
		wesnoth.set_dialog_active( false, "ok")
		wesnoth.set_dialog_callback(select, "gui_spell_chosen")
		wesnoth.set_dialog_callback(enchantments, "gui_enchantments")
		wesnoth.set_dialog_value( "Mana: " .. mana .. "/" .. max_mana , "gui_mana_display")
		if skills.skill_104 and enemy and mana >= 4 then
			wesnoth.set_dialog_value("Spiritual Strike (" .. tostring(skills.skill_104) .. ")", "gui_spell_chosen", 104 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/magic-missile.png", "gui_spell_chosen", 104, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 4", "gui_spell_chosen", 104 , "gui_spell_cost")
		end
		if skills.skill_107 and self then
			if mana >= tonumber(8 + skills.skill_107) then
				wesnoth.set_dialog_value("Spiritual Recovery (" .. tostring(skills.skill_107) .. ")", "gui_spell_chosen", 107 , "gui_spell_name")
				wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 107, "gui_spell_icon")
				wesnoth.set_dialog_value("Mana cost: " .. tostring(8 + skills.skill_107), "gui_spell_chosen", 107 , "gui_spell_cost")
			end
		end
		if skills.skill_203 and friendly and mana >= 1 then
			wesnoth.set_dialog_value("Flaming Weapon (" .. tostring(skills.skill_203) .. ")", "gui_spell_chosen", 203 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/sword-flaming.png", "gui_spell_chosen", 203, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",203 , "gui_spell_cost")
		end
		if skills.skill_208 and (enemy or empty) and mana >= 5 then
			wesnoth.set_dialog_value("Fireball (" .. tostring(skills.skill_208) .. ")", "gui_spell_chosen", 208 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/fireball.png", "gui_spell_chosen", 208, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen",208 , "gui_spell_cost")
		end
		if skills.skill_301 and enemy and mana >= 1 then
			wesnoth.set_dialog_value("Long Range Shot (" .. tostring(skills.skill_301) .. ")", "gui_spell_chosen", 301 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/bow-elven-magic.png", "gui_spell_chosen", 301, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1", "gui_spell_chosen",301 , "gui_spell_cost")
		end
		if skills.skill_303 and friendly and mana >= 1 then
			wesnoth.set_dialog_value("Leeches (" .. tostring(skills.skill_303) .. ")", "gui_spell_chosen", 303 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 303, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",303 , "gui_spell_cost")
		end
		if skills.skill_305 and empty and mana >= 5 then
			wesnoth.set_dialog_value("Animal Follower (" .. tostring(skills.skill_305) .. ")", "gui_spell_chosen", 305 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 305, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 5, then 1 per turn", "gui_spell_chosen",305 , "gui_spell_cost")
		end
		if skills.skill_403 and empty and mana >= 4 then
			wesnoth.set_dialog_value("Summon Shadow (" .. tostring(skills.skill_403) .. ")", "gui_spell_chosen", 403 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 403, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 4, then 1 per turn", "gui_spell_chosen",403 , "gui_spell_cost")
		end
		if skills.skill_406 and (enemy or empty) and mana >= 6 then
			local cooldown_lasting = false
			if cooldowns.skill_406 then
				if cooldowns.skill_406 > 0 then
					cooldown_lasting = true
				end
			end
			if cooldown_lasting == false then
				wesnoth.set_dialog_value("Poison Cloud (" .. tostring(skills.skill_406) .. ")", "gui_spell_chosen", 406 , "gui_spell_name")
				wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 406, "gui_spell_icon")
				wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen",406 , "gui_spell_cost")
			end
		end
		if skills.skill_408 and enemy and mana >= 5 then
			wesnoth.set_dialog_value("Shadow Blast (" .. tostring(skills.skill_408) .. ")", "gui_spell_chosen", 408 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/dark-missile.png", "gui_spell_chosen", 408, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen", 408 , "gui_spell_cost")
		end
		if skills.skill_502 and friendly and mana >= 2 then
			wesnoth.set_dialog_value("Divine Might (" .. tostring(skills.skill_502) .. ")", "gui_spell_chosen", 502 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 502, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 2 per turn", "gui_spell_chosen",502 , "gui_spell_cost")
		end
		if skills.skill_503 and enemy and mana >= 6 then
			wesnoth.set_dialog_value("Lightbeam (" .. tostring(skills.skill_503) .. ")", "gui_spell_chosen", 503 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/lightbeam.png", "gui_spell_chosen", 503, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen",503 , "gui_spell_cost")
		end
		if skills.skill_504 and friendly and mana >= 9 then
			wesnoth.set_dialog_value("Heal (" .. tostring(skills.skill_504) .. ")", "gui_spell_chosen", 504 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 504, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 9", "gui_spell_chosen",504 , "gui_spell_cost")
		end
		if skills.skill_507 and friendly and mana >= 1 then
			wesnoth.set_dialog_value("Holy Armor (" .. tostring(skills.skill_507) .. ")", "gui_spell_chosen", 507 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 507, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",507 , "gui_spell_cost")
		end
		if skills.skill_508 and (enemy or empty) and mana >= 11 then
			wesnoth.set_dialog_value("Divine Blast (" .. tostring(skills.skill_508) .. ")", "gui_spell_chosen", 508 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png)", "gui_spell_chosen", 508, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 11", "gui_spell_chosen",508 , "gui_spell_cost")
		end
		if skills.skill_509 and friendly and mana >= 1 then
			wesnoth.set_dialog_value("Magical Mirror (" .. tostring(skills.skill_509) .. ")", "gui_spell_chosen", 509 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 509, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen",509 , "gui_spell_cost")
		end
		if skills.skill_601 and friendly and mana >= 2 then
			wesnoth.set_dialog_value("Steel Skin (" .. tostring(skills.skill_601) .. ")", "gui_spell_chosen", 601 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 601, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 2 per turn", "gui_spell_chosen",601 , "gui_spell_cost")
		end
		if skills.skill_603 and enemy and mana >= 5 then
			wesnoth.set_dialog_value("Freezing Bolt (" .. tostring(skills.skill_603) .. ")", "gui_spell_chosen", 603 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/iceball.png", "gui_spell_chosen", 603, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 5", "gui_spell_chosen", 603 , "gui_spell_cost")
		end
		if skills.skill_604 and enemy and mana >= 6 then
			wesnoth.set_dialog_value("Inferno (" .. tostring(skills.skill_604) .. ")", "gui_spell_chosen", 604 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/fire-blast.png", "gui_spell_chosen", 604, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 604 , "gui_spell_cost")
		end
		if skills.skill_607 and empty and mana >= 6 then
			wesnoth.set_dialog_value("Create Golem (" .. tostring(skills.skill_607) .. ")", "gui_spell_chosen", 607 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 607, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 6, 1 per turn", "gui_spell_chosen", 607 , "gui_spell_cost")
		end
		if skills.skill_608 and (enemy or empty) and mana >= 11 then
			wesnoth.set_dialog_value("Grimcold Blast (" .. tostring(skills.skill_608) .. ")", "gui_spell_chosen", 608 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 608, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 11", "gui_spell_chosen", 608 , "gui_spell_cost")
		end
		if skills.skill_702 and empty and mana >= 7 then
			wesnoth.set_dialog_value("Summon Skeleton (" .. tostring(skills.skill_702) .. ")", "gui_spell_chosen", 702 , "gui_spell_name")
			wesnoth.set_dialog_value("units/undead-skeletal/skeleton.png~(magenta>black)", "gui_spell_chosen", 702, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 7", "gui_spell_chosen", 702 , "gui_spell_cost")
		end
		if skills.skill_703 and (enemy or empty) and mana >= 7 then
			if not (skills.skill_703 == 1 and empty) then
				wesnoth.set_dialog_value("Dark Blast (" .. tostring(skills.skill_703) .. ")", "gui_spell_chosen", 703 , "gui_spell_name")
				wesnoth.set_dialog_value("misc/dark-missile.png", "gui_spell_chosen", 703, "gui_spell_icon")
				wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 703 , "gui_spell_cost")
			end
		end
		if skills.skill_704 and friendly and mana >= 1 then
			wesnoth.set_dialog_value("Foul Cloak (" .. tostring(skills.skill_704) .. ")", "gui_spell_chosen", 704 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 704, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 1 per turn", "gui_spell_chosen", 704 , "gui_spell_cost")
		end
		if skills.skill_705 and (enemy or empty) and mana >= 10 then
			wesnoth.set_dialog_value("Freezing Wave (" .. tostring(skills.skill_705) .. ")", "gui_spell_chosen", 705 , "gui_spell_name")
			wesnoth.set_dialog_value("attacks/iceball.png", "gui_spell_chosen", 705, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 10", "gui_spell_chosen", 705 , "gui_spell_cost")
		end
		if skills.skill_706 and empty and mana >= 8 then
			wesnoth.set_dialog_value("Summon Skeletal Archer (" .. tostring(skills.skill_706) .. ")", "gui_spell_chosen", 706 , "gui_spell_name")
			wesnoth.set_dialog_value("units/undead-skeletal/skeleton-archer.png~(magenta>black)", "gui_spell_chosen", 706, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 8", "gui_spell_chosen", 706 , "gui_spell_cost")
		end
		if skills.skill_707 and (enemy or empty) and mana >= 6 then
			wesnoth.set_dialog_value("Shades of the Fallen (" .. tostring(skills.skill_707) .. ")", "gui_spell_chosen", 707 , "gui_spell_name")
			wesnoth.set_dialog_value("misc/blank-hex.png", "gui_spell_chosen", 707, "gui_spell_icon")
			wesnoth.set_dialog_value("Mana cost: 6", "gui_spell_chosen", 707 , "gui_spell_cost")
		end
	end

	local function postshow()
	end

	local chose = wesnoth.show_dialog(dialog, preshow, postshow)
	if spell_chosen and chose == -1 then
		unit.attacks_left = unit.attacks_left - 1
		for i = 1,#unit do
			if unit[i][1] == "variables" then
				unit[i][2].mana = unit[i][2].mana - spells_costs[spell_chosen]
			end
		end
		unit = wesnoth.display_mana(unit)
		wesnoth.put_unit(unit)
		if enchantment_cost[spell_chosen] > 0 and summon[spell_chosen] == 0 then
			for i=1,#target do
				if target[i][1] == "variables" then
					target[i][2].enchanted = true
					local function check_for_enchantments(skill)
						if spell_chosen == skill then
							if target[i][2][spells_names[skill]]== true then
								if target[i][2][spells_names[skill] .. "_level"] < skills["skill_" .. skill] then
									target[i][2][spells_names[skill] .. "_level"] = skills["skill_" .. skill]
									for j=1,#target do
										if target[j][1] == "enchantment" then
											if target[j][2].name == spells_names[skill] then
												target[j][2].caster = side_number
											end
										end
									end
								end
							else
								target[i][2][spells_names[skill]] = true
								target[i][2][spells_names[skill] .. "_level"] = skills["skill_" .. skill]
								if skill == 704 and skills.skill_717 then
									target[i][2]["foul_cloak_level"] = skills.skill_704 + skills.skill_717
								end
								table.insert( target[i][2] , { "enchantment" , { name=spells_names[skill], caster=side_number, cost=enchantment_cost[skill], number=skill } } )
							end
						end
					end
					check_for_enchantments(203)
					check_for_enchantments(303)
					check_for_enchantments(502)
					check_for_enchantments(507)
					check_for_enchantments(509)
					check_for_enchantments(601)
					check_for_enchantments(704)
				end
			end
			wesnoth.put_unit(target)
		else
			wesnoth.fire_event(spells_names[spell_chosen],unit.x,unit.y,target.x,target.y)
		end
		wesnoth.fire_event("attack end",unit.x,unit.y,target.x,target.y)
	end
end
